console.log("Start initializing EN");
EN.setup({
    'rte': {
        'smartEditMode': true,
        'smartEnd': true,
        'smartEndSelector': 'div.en-note-container',
        'trackStateChanges': ${trackStateChanges},
        'trackValueChanges': ${trackValueChanges},
        'trackEnabledChanges': ${trackEnabledChanges},
        'imageConfig': {
            'imageClickEvents': true,
        },
        'placeholder': ${placeholder},
        'typebehind': {
            'url': true,
            'email': true,
            'phone': ${phoneNumber},
        },
        'smartScroll': true,
        'smartHeight': true,
        'resources': {},
        'mutationObserver': ${mutationObserver},
        'cryptLegacy': false,
        'locale': ${locale},
        'richLinks': ${richlinkEnabled},
        'richLinkCaching': ${richlinkEnabled},
        //'smartDelete': true,
    },
    'keyboard': {
        'shortcuts': true,
        'editing': true,
    },
    'find': {},
    'accentuate': {
        'clearOnClickSelector': ''
    },
    'debug': ${ceDebug}
});

function handleResize() {
    noteEditor.onWebViewResized();
}
window.addEventListener("resize", handleResize);

EN.setupCopyHandler();

console.log("Done initializing EN");

