console.log("Start initializing EN for Templates");
EN.setup({
    'note': {
        'title': ${noteTitle},
        'source': ${noteSource},
        'sourceURL': ${noteSourceURL},
        'sourceApplication': ${noteSourceApplication},
        'contentClass': ${noteContentClass},
        'guid': ${noteGuid},
        'newNote': ${newNote},
        'notebookGUID': ${notebookGuid}
    },
    'rte': {
            'locale': ${locale},
        },
    'templates': {
        'enabled': ${templatesEnabled},
        'url': ${templatesUrl}
      },

    // https://www.evernote.com/shard/s12/sh/61fee335-35d8-4eb2-8a11-726ab653049b/430c8d2dd1364ae5
    'enabledApps': [ 'ce', 'templatemanager' ],
    'lockDefaultApp': true,
    'defaultApp': ${defaultApp},
    'platform': {
        'confirmAlert': '1',
        'optionsPopup': '1',
        'formDialog': '1',
        'actionNotification': '1'
      },
    'user': {
        'shardID': ${userShardId},
        'displayName': ${userDisplayName},
        'userID': ${userId},
        'authToken': ${userAuthToken},
        'serviceHost': ${userServiceHost},
        'accountType': ${userAccountType}
      },
    'stayInEditMode': false,
    'debug': ${ceDebug},
    'darkmode': ${darkMode}
});

function handleResize() {
    noteEditor.onWebViewResized();
}
window.addEventListener("resize", handleResize);

EN.setupCopyHandler();

console.log("Done initializing EN");

